create or replace PROCEDURE  SCO_IMPORT.IMPORT_GIROFLE IS

--
-- Procédure de migration de SCO_IMPORT vers SCO_SCOLARITE du 21/05/2013 à  exécuter depuis le user GRHUM
--
-- Rem : fichier encodé UTF-8

--
--
-- Fichier : 8/11
-- Type : PLSQL
-- Schema : SCO_IMPORT
-- Numero de version : 0.1.0.8
-- Date de publication : 21/05/2013
-- Auteur(s) : Association Cocktail
--
--

is_fieldcstructure_exists varchar2(10);
is_formuleSession1_notEmpty integer;
is_formuleSession2_notEmpty integer;
idSession integer;
CURSOR importEC IS SELECT ID_EC FROM SCO_IMPORT.IMPORT_EC;
CURSOR importDiplome IS SELECT ID_DIPLOME,ANNEE FROM SCO_IMPORT.IMPORT_DIPLOME;
unEC int;
idVersionDiplome int;
unDiplome int;
uneAnnee int;

BEGIN

	-- Introduction
	DBMS_OUTPUT.PUT_LINE('Démarrage de l importation des données...');
  
  	-- Vidage des tables d'import
  	EXECUTE IMMEDIATE('DELETE FROM SCO_IMPORT.Z_ID');
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.CREDITABLE');
  	EXECUTE Immediate('DELETE FROM SCO_SCOLARITE.DESCRIPTIF');
 	EXECUTE Immediate('DELETE FROM SCO_SCOLARITE.DESCRIPTIF_CHAMP_CONTENU');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.LIEN');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.LIEN_COMPOSER');
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.AP');
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.EC'); 
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.UE');
    EXECUTE Immediate('DELETE FROM SCO_SCOLARITE.REGROUPEMENT');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.PARCOURS');
    EXECUTE Immediate('DELETE FROM SCO_SCOLARITE.PERIODE');
    EXECUTE Immediate('DELETE FROM SCO_SCOLARITE.VERSION_DIPLOME');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.DIPLOME'); 
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.FORMULE');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.SESSION_COMPOSANT');
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.COMPOSANT');  
  	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.DOMAINE');  
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.SPECIALITE');  
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.MODE_AP');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.TYPE_AP');
    EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.GRADE_UNIVERSITAIRE');   
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_SPECIALISATION');  
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_IMPORT.IMPORT_VOCATION');
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_SCOLARITE.TYPE_FORMATION');  
	-- EXECUTE IMMEDIATE('TRUNCATE TABLE SCO_SCOLARITE.TYPE_ORGANISATION'); 
	EXECUTE IMMEDIATE('DELETE FROM SCO_SCOLARITE.STRUCTURES_COMPOSANT');
	DBMS_OUTPUT.PUT_LINE('Tables de SCO_SCOLARITE vidées');
  	COMMIT;

  	-- Alimentation des tables temporaires
	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_AP.ID_AP, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'AP' FROM SCO_IMPORT.IMPORT_AP;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_EC.ID_EC, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'EC' FROM SCO_IMPORT.IMPORT_EC;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_UE.ID_UE, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'UE' FROM SCO_IMPORT.IMPORT_UE;
  	INSERT INTO SCO_IMPORT.Z_ID (ID_SOUR, ID_DEST, ID_TYPE)
  	SELECT SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME, SCO_SCOLARITE.COMPOSANT_SEQ.nextval, 'DI' FROM SCO_IMPORT.IMPORT_DIPLOME;
  	DBMS_OUTPUT.PUT_LINE('Alimentation des tables temporaires : OK');
 
  	-- Insertion des données de DOMAINE
	INSERT INTO SCO_SCOLARITE.DOMAINE (ID_DOMAINE, CODE, LC_DOMAINE, LL_DOMAINE, IS_READ_ONLY)
  	SELECT ID_DOMAINE, CODE, LIBELLE_COURT, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_DOMAINE;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Domaines : OK');

    -- Insertion des données de GRADE
    INSERT INTO SCO_SCOLARITE.GRADE_UNIVERSITAIRE (ID_GRADE_UNIVERSITAIRE,TYPE_GRADE_UNIVERSITAIRE,LIBELLE,NB_UNITES_TEMPS,FILIERE)
    SELECT ID_GRADE, CODE, LIBELLE, 1, FILIERE FROM SCO_IMPORT.IMPORT_GRADE;    
  
  	-- Insertion des données de SPECIALITES
	INSERT INTO SCO_SCOLARITE.SPECIALITE (ID_SPECIALITE, CODE, LC_SPECIALITE, LL_SPECIALITE, IS_READ_ONLY)
  	SELECT ID_SPECIALITE, CODE, LIBELLE_COURT, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_SPECIALITE;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Spécialités : OK');
  
  	-- Insertion des données de MODE_AP
	INSERT INTO SCO_SCOLARITE.MODE_AP (ID_MODE_AP, CODE, LIBELLE, IS_READ_ONLY)
  	SELECT ID_MODE_AP, CODE, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_MODE_AP;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Modes d''AP : OK');

   	-- Insertion des données de TYPE_AP
	INSERT INTO SCO_SCOLARITE.TYPE_AP (ID_TYPE_AP, CODE, LIBELLE, IS_READ_ONLY)
 	SELECT ID_TYPE_AP, CODE, LIBELLE, '1' FROM SCO_IMPORT.IMPORT_TYPE_AP;
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Types d''AP : OK');

  	-- Insertion des données d'AP
  	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, CODE, LL_COMPOSANT)
  	SELECT ID_DEST, '2', CODE, LIBELLE 
  	FROM SCO_IMPORT.IMPORT_AP, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_AP.ID_AP
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'AP';
    INSERT INTO SCO_SCOLARITE.AP (ID_AP, TYPE_AP_ID, MODE_AP_ID, VALEUR_HEURES, SEUIL, NB_GROUPES)
  	SELECT ID_DEST, TYPE_AP_ID, MODE_AP_ID, VALEUR_HEURES, SEUIL, NB_GROUPES 
  	FROM SCO_IMPORT.IMPORT_AP, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_AP.ID_AP
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'AP';
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table d''AP : OK');
  
  	-- Insertion des données d'EC
	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
  	SELECT ID_DEST, '3', CODE, LIBELLE||' ', LIBELLE_COURT
  	FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
  	
  INSERT INTO SCO_SCOLARITE.EC (ID_EC)
  	SELECT ID_DEST FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
    
  INSERT INTO SCO_SCOLARITE.CREDITABLE(ID_CREDITABLE, COMPOSANT_ID,LIEN_ID, CREDIT_ECTS,TRAVAIL_ETUDIANT,BASE_NOTE,SANS_NOTE)
    SELECT SCO_SCOLARITE.CREDITABLE_SEQ.NEXTVAL, ID_DEST, NULL, CREDIT_ECTS, TRAVAIL_ETUDIANT, BASE_NOTE, 0 
    FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table EC : OK');
    
  --insertion des formules  
  OPEN importEC;
	LOOP
		FETCH importEC into unEC;
    EXIT WHEN importEC%NOTFOUND;
    
    SELECT LENGTH(FORMULE1) INTO is_formuleSession1_notEmpty from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
    WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
    IF(is_formuleSession1_notEmpty > 0) then
      SELECT  SCO_SCOLARITE.SESSION_COMPOSANT_SEQ.NEXTVAL INTO  idSession FROM dual;
      INSERT INTO SCO_SCOLARITE.SESSION_COMPOSANT (ID_SESSION_COMPOSANT, COMPOSANT_ID, ACTIVE, LIBELLE) 
      SELECT idSession, ID_DEST, 1, 'Session 1' from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
      WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
      INSERT INTO SCO_SCOLARITE.FORMULE (ID_FORMULE, SESSION_COMPOSANT_ID, TYPE_FORMULE_ID, FORMULE)
      SELECT SCO_SCOLARITE.FORMULE_SEQ.NEXTVAL, idSession, 1, SCO_IMPORT.IMPORT_EC.FORMULE1 from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
      WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';      
      
      SELECT LENGTH(FORMULE2) INTO is_formuleSession2_notEmpty from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
      WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
      SELECT  SCO_SCOLARITE.SESSION_COMPOSANT_SEQ.NEXTVAL INTO  idSession FROM dual;
      IF(is_formuleSession2_notEmpty > 0) then
        INSERT INTO SCO_SCOLARITE.SESSION_COMPOSANT (ID_SESSION_COMPOSANT, COMPOSANT_ID, ACTIVE, LIBELLE) 
        SELECT idSession, ID_DEST, 1, 'Session 2' from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
        WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
        INSERT INTO SCO_SCOLARITE.FORMULE (ID_FORMULE, SESSION_COMPOSANT_ID, TYPE_FORMULE_ID, FORMULE)
        SELECT SCO_SCOLARITE.FORMULE_SEQ.NEXTVAL, idSession, 1, SCO_IMPORT.IMPORT_EC.FORMULE2 from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
        WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';      
      ELSE
        INSERT INTO SCO_SCOLARITE.SESSION_COMPOSANT (ID_SESSION_COMPOSANT, COMPOSANT_ID, ACTIVE, LIBELLE) 
        SELECT idSession, ID_DEST, 0, 'Session 2' from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
        WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';        
        INSERT INTO SCO_SCOLARITE.FORMULE (ID_FORMULE, SESSION_COMPOSANT_ID, TYPE_FORMULE_ID, FORMULE)  SELECT SCO_SCOLARITE.FORMULE_SEQ.NEXTVAL, idSession, 1, null from DUAL; 
      END IF;
      
      SELECT  SCO_SCOLARITE.SESSION_COMPOSANT_SEQ.NEXTVAL INTO  idSession FROM dual;
      INSERT INTO SCO_SCOLARITE.SESSION_COMPOSANT (ID_SESSION_COMPOSANT, COMPOSANT_ID, ACTIVE, LIBELLE) 
      SELECT idSession, ID_DEST, 0, 'Session 3' from SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
      WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';        
      INSERT INTO SCO_SCOLARITE.FORMULE (ID_FORMULE, SESSION_COMPOSANT_ID, TYPE_FORMULE_ID, FORMULE)  SELECT SCO_SCOLARITE.FORMULE_SEQ.NEXTVAL, idSession, 1, null from DUAL; 
    END IF;        
    
  END LOOP;
	CLOSE importEC;
  	
  	-- Insertion de la composante d'un EC
	OPEN importEC;
	LOOP
		FETCH importEC into unEC;
        EXIT WHEN importEC%NOTFOUND;
        SELECT C_STRUCTURE INTO is_fieldcstructure_exists FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
			IF(is_fieldcstructure_exists > 0) then
          		INSERT INTO SCO_SCOLARITE.STRUCTURES_COMPOSANT (COMPOSANT_ID, C_STRUCTURE)
          		SELECT ID_DEST, C_STRUCTURE
          		FROM SCO_IMPORT.IMPORT_EC, SCO_IMPORT.Z_ID 
          		WHERE SCO_IMPORT.IMPORT_EC.ID_EC=unEC
              	AND SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_EC.ID_EC
          		AND SCO_IMPORT.Z_ID.ID_TYPE = 'EC';
        	END IF;
	END LOOP;
	CLOSE importEC;
  
  	-- Insertion des données de liaison entre AP et EC
	  INSERT INTO SCO_SCOLARITE.LIEN (ID_LIEN, PARENT_ID, CHILD_ID, TYPE_LIEN_ID)
  	SELECT SCO_SCOLARITE.LIEN_SEQ.nextval, ALIAS_EC.ID_DEST, ALIAS_AP.ID_DEST, '1'
  	FROM SCO_IMPORT.IMPORT_LIEN, SCO_IMPORT.Z_ID ALIAS_AP, SCO_IMPORT.Z_ID ALIAS_EC
  	WHERE (SCO_IMPORT.IMPORT_LIEN.ENFANT_ID = ALIAS_AP.ID_SOUR
  	AND ALIAS_AP.ID_TYPE = 'AP')
  	AND (SCO_IMPORT.IMPORT_LIEN.PARENT_ID = ALIAS_EC.ID_SOUR
  	AND ALIAS_EC.ID_TYPE = 'EC') 
   AND SCO_IMPORT.IMPORT_LIEN.NATURE_LIEN_ID = 1;
    
    INSERT INTO SCO_SCOLARITE.LIEN_COMPOSER (ID_LIEN_COMPOSER)
  	SELECT SCO_SCOLARITE.LIEN.ID_LIEN
  	FROM SCO_SCOLARITE.LIEN, SCO_IMPORT.Z_ID ALIAS_AP, SCO_IMPORT.Z_ID ALIAS_EC
  	WHERE (SCO_SCOLARITE.LIEN.CHILD_ID = ALIAS_AP.ID_DEST
  	AND ALIAS_AP.ID_TYPE = 'AP')
  	AND (SCO_SCOLARITE.LIEN.PARENT_ID = ALIAS_EC.ID_DEST
  	AND ALIAS_EC.ID_TYPE = 'EC');
    --AND SCO_IMPORT.IMPORT_LIEN.NATURE_LIEN_ID = 1;
    
    -- Insertion des données de liaison entre EC ET UE
	  INSERT INTO SCO_SCOLARITE.LIEN (ID_LIEN, PARENT_ID, CHILD_ID, TYPE_LIEN_ID)
  	SELECT SCO_SCOLARITE.LIEN_SEQ.nextval, ALIAS_UE.ID_DEST, ALIAS_EC.ID_DEST, '1'
  	FROM SCO_IMPORT.IMPORT_LIEN, SCO_IMPORT.Z_ID ALIAS_EC, SCO_IMPORT.Z_ID ALIAS_UE
  	WHERE (SCO_IMPORT.IMPORT_LIEN.ENFANT_ID = ALIAS_EC.ID_SOUR
  	AND ALIAS_EC.ID_TYPE = 'EC')
  	AND (SCO_IMPORT.IMPORT_LIEN.PARENT_ID = ALIAS_UE.ID_SOUR
  	AND ALIAS_UE.ID_TYPE = 'UE') 
    AND SCO_IMPORT.IMPORT_LIEN.NATURE_LIEN_ID=2;
    
    INSERT INTO SCO_SCOLARITE.LIEN_COMPOSER (ID_LIEN_COMPOSER)
  	SELECT SCO_SCOLARITE.LIEN.ID_LIEN
  	FROM SCO_SCOLARITE.LIEN, SCO_IMPORT.Z_ID ALIAS_EC, SCO_IMPORT.Z_ID ALIAS_UE
  	WHERE (SCO_SCOLARITE.LIEN.CHILD_ID = ALIAS_EC.ID_DEST
  	AND ALIAS_EC.ID_TYPE = 'EC')
  	AND (SCO_SCOLARITE.LIEN.PARENT_ID = ALIAS_UE.ID_DEST
  	AND ALIAS_UE.ID_TYPE = 'UE');
    --AND SCO_IMPOIMPORT_LIEN.NATURE_LIEN_ID=2;
    
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Lien : OK');
 
  	-- Insertion des données d'UE
	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, DOMAINE_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
  	SELECT ID_DEST, '4', DOMAINE_ID, CODE, LIBELLE||' ', LIBELLE_COURT
  	FROM SCO_IMPORT.IMPORT_UE, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_UE.ID_UE
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'UE';
  
  INSERT INTO SCO_SCOLARITE.UE (ID_UE)
  	SELECT ID_DEST FROM SCO_IMPORT.IMPORT_UE, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_UE.ID_UE
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'UE';
  
  INSERT INTO SCO_SCOLARITE.CREDITABLE(ID_CREDITABLE, COMPOSANT_ID,LIEN_ID, CREDIT_ECTS,TRAVAIL_ETUDIANT,BASE_NOTE,SANS_NOTE)
    SELECT SCO_SCOLARITE.CREDITABLE_SEQ.NEXTVAL, ID_DEST, NULL, CREDIT_ECTS, TRAVAIL_ETUDIANT, BASE_NOTE, 0 
    FROM SCO_IMPORT.IMPORT_UE, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_UE.ID_UE
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'UE';
  
  	DBMS_OUTPUT.PUT_LINE('Alimentation de la table UE : OK');
  
  	-- Insertion des données de PARCOURS
	/* INSERT INTO SCO_SCOLARITE.PARCOURS
	(ID, SPECIALITE_ID, VOCATION_ID, CODE, LIBELLE_COURT, LIBELLE)
	SELECT IMPORT_PARCOURS_SEQ.nextval, SCO_IMPORT.IMPORT_SPECIALISATION.ID, SCO_IMPORT.IMPORT_VOCATION.ID, MPAR_CODE, MPAR_ABREVIATION, MPAR_LIBELLE
	FROM SCOLARITE.SCOL_MAQUETTE_PARCOURS, SCO_IMPORT.IMPORT_SPECIALISATION, SCO_IMPORT.IMPORT_VOCATION
  	WHERE SCOLARITE.SCOL_MAQUETTE_PARCOURS.FSPN_KEY = SCO_IMPORT.IMPORT_SPECIALISATION.KEY
  	AND SCOLARITE.SCOL_MAQUETTE_PARCOURS.FVOC_CODE = SCO_IMPORT.IMPORT_VOCATION.CODE;
	DBMS_OUTPUT.PUT_LINE('Alimentation de la table Pacours : OK'); */
  
  	-- Insertion des données de DIPLOME
  	INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, DOMAINE_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
  	SELECT ID_DEST, '9', DOMAINE_ID, CODE, LIBELLE||' ', LIBELLE_COURT
  	FROM SCO_IMPORT.IMPORT_DIPLOME, SCO_IMPORT.Z_ID 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'DI';
    INSERT INTO SCO_SCOLARITE.DIPLOME
	(ID_DIPLOME, GRADE_UNIVERSITAIRE_ID, TYPE_ORGANISATION_ID, TYPE_FORMATION_ID, STATUT_FORMATION_ID, SISE_MESR, MENTION)
	SELECT ID_DEST, GRADE_UNIVERSITAIRE.ID_GRADE_UNIVERSITAIRE, TYPE_ORGANISATION.ID_TYPE_ORGANISATION, '1', STATUT_FORMATION.ID_STATUT_FORMATION, SISE_MESR, MENTION
	FROM SCO_IMPORT.IMPORT_DIPLOME, SCO_IMPORT.Z_ID, SCO_IMPORT.IMPORT_STATUT_FORMATION, SCO_SCOLARITE.STATUT_FORMATION, SCO_IMPORT.IMPORT_TYPE_ORGANISATION, SCO_SCOLARITE.TYPE_ORGANISATION, SCO_IMPORT.IMPORT_GRADE, SCO_SCOLARITE.GRADE_UNIVERSITAIRE 
  	WHERE SCO_IMPORT.Z_ID.ID_SOUR = SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME
  	AND SCO_IMPORT.Z_ID.ID_TYPE = 'DI'
  	AND SCO_IMPORT.IMPORT_DIPLOME.GRADE_UNIVERSITAIRE_ID = SCO_IMPORT.IMPORT_GRADE.ID_GRADE
  	AND SCO_IMPORT.IMPORT_GRADE.CODE = SCO_SCOLARITE.GRADE_UNIVERSITAIRE.TYPE_GRADE_UNIVERSITAIRE
  	AND SCO_IMPORT.IMPORT_DIPLOME.TYPE_ORGANISATION_ID = SCO_IMPORT.IMPORT_TYPE_ORGANISATION.ID_TYPE_ORGANISATION
  	AND SCO_IMPORT.IMPORT_TYPE_ORGANISATION.CODE = SUBSTR(SCO_SCOLARITE.TYPE_ORGANISATION.TYPE_ORGANISATION, 0, 1)
--    AND SCO_SCOLARITE.TYPE_ORGANISATION.TYPE_ORGANISATION <> 'AUTRES'
  	AND SCO_IMPORT.IMPORT_DIPLOME.STATUT_FORMATION_ID = SCO_IMPORT.IMPORT_STATUT_FORMATION.ID_STATUT_FORMATION
  	AND SCO_IMPORT.IMPORT_STATUT_FORMATION.CODE = SCO_SCOLARITE.STATUT_FORMATION.CODE;
	
 -- insère la version de diplome
  OPEN importDIPLOME;
	LOOP
		FETCH importDIPLOME into unDiplome, uneAnnee;
    EXIT WHEN importDIPLOME%NOTFOUND;
    
    SELECT  SCO_SCOLARITE.COMPOSANT_SEQ.NEXTVAL INTO  idVersionDiplome FROM dual;    
    
    INSERT INTO SCO_SCOLARITE.COMPOSANT (ID_COMPOSANT, TYPE_COMPOSANT_ID, CODE, LL_COMPOSANT, LC_COMPOSANT)
      SELECT idVersionDiplome, '8', 'v 1.0 - '||CODE, 'Version du diplome' || LIBELLE, LIBELLE_COURT
      FROM SCO_IMPORT.IMPORT_DIPLOME, SCO_IMPORT.Z_ID
      WHERE SCO_IMPORT.Z_ID.ID_SOUR = unDiplome
      AND SCO_IMPORT.Z_ID.ID_TYPE = 'DI'
      AND SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME= SCO_IMPORT.Z_ID.ID_SOUR ;
      
    
    INSERT INTO SCO_SCOLARITE.VERSION_DIPLOME (ID_VERSION_DIPLOME, ANNEE) 
    VALUES(idVersionDiplome, uneAnnee);
          
   INSERT INTO SCO_SCOLARITE.LIEN(ID_LIEN, PARENT_ID, CHILD_ID, TYPE_LIEN_ID)
   SELECT SCO_SCOLARITE.LIEN_SEQ.NEXTVAL,ID_DEST , idVersionDiplome, 2
    FROM SCO_IMPORT.IMPORT_DIPLOME, SCO_IMPORT.Z_ID
     WHERE SCO_IMPORT.Z_ID.ID_SOUR = unDiplome
      AND SCO_IMPORT.Z_ID.ID_TYPE = 'DI'
      AND SCO_IMPORT.IMPORT_DIPLOME.ID_DIPLOME= SCO_IMPORT.Z_ID.ID_SOUR ;      
      
  END LOOP;
	CLOSE importDIPLOME;
  
  
  DBMS_OUTPUT.PUT_LINE('Alimentation de la table Diplomes : OK');
  
 
  	COMMIT;
  
END;
/
